#
# Copyright (C) 2014 The Android Open Source Project
# Copyright 2015 Sony Corporation.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

ifeq (linux,$(findstring linux,$(TARGET_PRODUCT)))
# do compile only bare linux target.

LOCAL_PATH := $(call my-dir)

include $(CLEAR_VARS)

VERSION = 1
PATCHLEVEL = 23
SUBLEVEL = 1
EXTRAVERSION =
NAME = Unnamed

BB_VER = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

# DO NOT REMOVE next line, helper script uses as automatic edit marker.
# BEGIN LOCAL_SRC_FILES

#This is temporary
#busybox cannot work in clang environment
#use prebiuld binary in gcc

LOCAL_SRC_FILES := busybox

#LOCAL_SRC_FILES := \
	applets/applets.c \
	archival/ar.c \
	archival/bbunzip.c \
	archival/bzip2.c \
	archival/cpio.c \
	archival/gzip.c \
	archival/lzop.c \
	archival/tar.c \
	archival/unzip.c \
	archival/libarchive/data_align.c \
	archival/libarchive/data_extract_all.c \
	archival/libarchive/data_extract_to_command.c \
	archival/libarchive/data_extract_to_stdout.c \
	archival/libarchive/data_skip.c \
	archival/libarchive/decompress_bunzip2.c \
	archival/libarchive/decompress_gunzip.c \
	archival/libarchive/decompress_uncompress.c \
	archival/libarchive/decompress_unlzma.c \
	archival/libarchive/decompress_unxz.c \
	archival/libarchive/filter_accept_all.c \
	archival/libarchive/filter_accept_list.c \
	archival/libarchive/filter_accept_reject_list.c \
	archival/libarchive/find_list_entry.c \
	archival/libarchive/get_header_ar.c \
	archival/libarchive/get_header_cpio.c \
	archival/libarchive/get_header_tar.c \
	archival/libarchive/header_list.c \
	archival/libarchive/header_skip.c \
	archival/libarchive/header_verbose_list.c \
	archival/libarchive/init_handle.c \
	archival/libarchive/lzo1x_1.c \
	archival/libarchive/lzo1x_1o.c \
	archival/libarchive/lzo1x_d.c \
	archival/libarchive/open_transformer.c \
	archival/libarchive/seek_by_jump.c \
	archival/libarchive/seek_by_read.c \
	archival/libarchive/unpack_ar_archive.c \
	console-tools/chvt.c \
	console-tools/clear.c \
	console-tools/deallocvt.c \
	console-tools/dumpkmap.c \
	console-tools/fgconsole.c \
	console-tools/kbd_mode.c \
	console-tools/loadfont.c \
	console-tools/loadkmap.c \
	console-tools/openvt.c \
	console-tools/reset.c \
	console-tools/resize.c \
	console-tools/setconsole.c \
	console-tools/setkeycodes.c \
	console-tools/setlogcons.c \
	console-tools/showkey.c \
	coreutils/basename.c \
	coreutils/cal.c \
	coreutils/cat.c \
	coreutils/catv.c \
	coreutils/chgrp.c \
	coreutils/chmod.c \
	coreutils/chown.c \
	coreutils/chroot.c \
	coreutils/cksum.c \
	coreutils/comm.c \
	coreutils/cp.c \
	coreutils/cut.c \
	coreutils/date.c \
	coreutils/dd.c \
	coreutils/df.c \
	coreutils/dirname.c \
	coreutils/dos2unix.c \
	coreutils/du.c \
	coreutils/echo.c \
	coreutils/env.c \
	coreutils/expand.c \
	coreutils/expr.c \
	coreutils/false.c \
	coreutils/fold.c \
	coreutils/fsync.c \
	coreutils/head.c \
	coreutils/hostid.c \
	coreutils/id.c \
	coreutils/install.c \
	coreutils/ln.c \
	coreutils/logname.c \
	coreutils/ls.c \
	coreutils/md5_sha1_sum.c \
	coreutils/mkdir.c \
	coreutils/mkfifo.c \
	coreutils/mknod.c \
	coreutils/mv.c \
	coreutils/nice.c \
	coreutils/nohup.c \
	coreutils/od.c \
	coreutils/printenv.c \
	coreutils/printf.c \
	coreutils/pwd.c \
	coreutils/readlink.c \
	coreutils/realpath.c \
	coreutils/rm.c \
	coreutils/rmdir.c \
	coreutils/seq.c \
	coreutils/shuf.c \
	coreutils/sleep.c \
	coreutils/sort.c \
	coreutils/split.c \
	coreutils/stat.c \
	coreutils/stty.c \
	coreutils/sum.c \
	coreutils/sync.c \
	coreutils/tac.c \
	coreutils/tail.c \
	coreutils/tee.c \
	coreutils/test.c \
	coreutils/test_ptr_hack.c \
	coreutils/touch.c \
	coreutils/tr.c \
	coreutils/true.c \
	coreutils/tty.c \
	coreutils/uname.c \
	coreutils/uniq.c \
	coreutils/unlink.c \
	coreutils/usleep.c \
	coreutils/uudecode.c \
	coreutils/uuencode.c \
	coreutils/wc.c \
	coreutils/who.c \
	coreutils/whoami.c \
	coreutils/yes.c \
	coreutils/libcoreutils/cp_mv_stat.c \
	coreutils/libcoreutils/getopt_mk_fifo_nod.c \
	debianutils/mktemp.c \
	debianutils/which.c \
	e2fsprogs/chattr.c \
	e2fsprogs/e2fs_lib.c \
	e2fsprogs/fsck.c \
	e2fsprogs/lsattr.c \
	e2fsprogs/tune2fs.c \
	editors/awk.c \
	editors/cmp.c \
	editors/diff.c \
	editors/ed.c \
	editors/patch.c \
	editors/sed.c \
	editors/vi.c \
	findutils/find.c \
	findutils/grep.c \
	findutils/xargs.c \
	init/halt.c \
	libbb/appletlib.c \
	libbb/ask_confirmation.c \
	libbb/bb_askpass.c \
	libbb/bb_bswap_64.c \
	libbb/bb_do_delay.c \
	libbb/bb_pwd.c \
	libbb/bb_qsort.c \
	libbb/bb_strtonum.c \
	libbb/change_identity.c \
	libbb/chomp.c \
	libbb/compare_string_array.c \
	libbb/concat_path_file.c \
	libbb/concat_subpath_file.c \
	libbb/copy_file.c \
	libbb/copyfd.c \
	libbb/correct_password.c \
	libbb/crc32.c \
	libbb/default_error_retval.c \
	libbb/device_open.c \
	libbb/dump.c \
	libbb/endofname.c \
	libbb/executable.c \
	libbb/fclose_nonstdin.c \
	libbb/fflush_stdout_and_exit.c \
	libbb/fgets_str.c \
	libbb/find_mount_point.c \
	libbb/find_pid_by_name.c \
	libbb/find_root_device.c \
	libbb/full_write.c \
	libbb/get_console.c \
	libbb/get_cpu_count.c \
	libbb/get_last_path_component.c \
	libbb/get_line_from_file.c \
	libbb/get_shell_name.c \
	libbb/get_volsize.c \
	libbb/getopt32.c \
	libbb/getpty.c \
	libbb/hash_md5_sha.c \
	libbb/herror_msg.c \
	libbb/human_readable.c \
	libbb/in_ether.c \
	libbb/inet_cksum.c \
	libbb/inet_common.c \
	libbb/info_msg.c \
	libbb/inode_hash.c \
	libbb/isdirectory.c \
	libbb/kernel_version.c \
	libbb/last_char_is.c \
	libbb/lineedit.c \
	libbb/lineedit_ptr_hack.c \
	libbb/llist.c \
	libbb/logenv.c \
	libbb/login.c \
	libbb/loop.c \
	libbb/make_directory.c \
	libbb/makedev.c \
	libbb/match_fstype.c \
	libbb/messages.c \
	libbb/missing_syscalls.c \
	libbb/mode_string.c \
	libbb/nuke_str.c \
	libbb/obscure.c \
	libbb/parse_config.c \
	libbb/parse_mode.c \
	libbb/percent_decode.c \
	libbb/perror_msg.c \
	libbb/perror_nomsg.c \
	libbb/perror_nomsg_and_die.c \
	libbb/pidfile.c \
	libbb/platform.c \
	libbb/print_flags.c \
	libbb/printable.c \
	libbb/printable_string.c \
	libbb/process_escape_sequence.c \
	libbb/procps.c \
	libbb/progress.c \
	libbb/ptr_to_globals.c \
	libbb/pw_encrypt.c \
	libbb/read.c \
	libbb/read_key.c \
	libbb/read_printf.c \
	libbb/recursive_action.c \
	libbb/remove_file.c \
	libbb/replace.c \
	libbb/rtc.c \
	libbb/run_shell.c \
	libbb/safe_gethostname.c \
	libbb/safe_poll.c \
	libbb/safe_strncpy.c \
	libbb/safe_write.c \
	libbb/setup_environment.c \
	libbb/signals.c \
	libbb/simplify_path.c \
	libbb/single_argv.c \
	libbb/skip_whitespace.c \
	libbb/speed_table.c \
	libbb/str_tolower.c \
	libbb/strrstr.c \
	libbb/sysconf.c \
	libbb/systemd_support.c \
	libbb/time.c \
	libbb/trim.c \
	libbb/u_signal_names.c \
	libbb/udp_io.c \
	libbb/unicode.c \
	libbb/update_passwd.c \
	libbb/utmp.c \
	libbb/uuencode.c \
	libbb/vdprintf.c \
	libbb/verror_msg.c \
	libbb/vfork_daemon_rexec.c \
	libbb/warn_ignoring_args.c \
	libbb/wfopen.c \
	libbb/wfopen_input.c \
	libbb/write.c \
	libbb/xatonum.c \
	libbb/xconnect.c \
	libbb/xfunc_die.c \
	libbb/xfuncs.c \
	libbb/xfuncs_printf.c \
	libbb/xgetcwd.c \
	libbb/xgethostbyname.c \
	libbb/xreadlink.c \
	libbb/xrealloc_vector.c \
	libbb/xregcomp.c \
	libpwdgrp/pwd_grp.c \
	libpwdgrp/uidgid_get.c \
	loginutils/getty.c \
	loginutils/login.c \
	loginutils/passwd.c \
	loginutils/su.c \
	miscutils/adjtimex.c \
	miscutils/chrt.c \
	miscutils/conspy.c \
	miscutils/crontab.c \
	miscutils/dc.c \
	miscutils/devmem.c \
	miscutils/eject.c \
	miscutils/fbsplash.c \
	miscutils/flash_eraseall.c \
	miscutils/flash_lock_unlock.c \
	miscutils/flashcp.c \
	miscutils/ionice.c \
	miscutils/less.c \
	miscutils/makedevs.c \
	miscutils/microcom.c \
	miscutils/mountpoint.c \
	miscutils/nandwrite.c \
	miscutils/raidautorun.c \
	miscutils/readahead.c \
	miscutils/rfkill.c \
	miscutils/rx.c \
	miscutils/setserial.c \
	miscutils/setsid.c \
	miscutils/strings.c \
	miscutils/time.c \
	miscutils/timeout.c \
	miscutils/ttysize.c \
	miscutils/ubi_tools.c \
	modutils/modinfo.c \
	modutils/modprobe-small.c \
	modutils/modutils.c \
	networking/arp.c \
	networking/arping.c \
	networking/brctl.c \
	networking/ether-wake.c \
	networking/ftpgetput.c \
	networking/hostname.c \
	networking/ifconfig.c \
	networking/ifenslave.c \
	networking/ifplugd.c \
	networking/ifupdown.c \
	networking/inetd.c \
	networking/interface.c \
	networking/ip.c \
	networking/ipcalc.c \
	networking/isrv.c \
	networking/isrv_identd.c \
	networking/nameif.c \
	networking/nbd-client.c \
	networking/nc.c \
	networking/netstat.c \
	networking/nslookup.c \
	networking/ntpd.c \
	networking/ping.c \
	networking/pscan.c \
	networking/route.c \
	networking/slattach.c \
	networking/tcpudp.c \
	networking/tcpudp_perhost.c \
	networking/telnetd.c \
	networking/tftp.c \
	networking/traceroute.c \
	networking/tunctl.c \
	networking/vconfig.c \
	networking/wget.c \
	networking/whois.c \
	networking/zcip.c \
	networking/libiproute/ip_parse_common_args.c \
	networking/libiproute/ipaddress.c \
	networking/libiproute/iplink.c \
	networking/libiproute/iproute.c \
	networking/libiproute/iprule.c \
	networking/libiproute/iptunnel.c \
	networking/libiproute/libnetlink.c \
	networking/libiproute/ll_addr.c \
	networking/libiproute/ll_map.c \
	networking/libiproute/ll_proto.c \
	networking/libiproute/ll_types.c \
	networking/libiproute/rt_names.c \
	networking/libiproute/rtm_map.c \
	networking/libiproute/utils.c \
	networking/udhcp/arpping.c \
	networking/udhcp/common.c \
	networking/udhcp/dhcpc.c \
	networking/udhcp/domain_codec.c \
	networking/udhcp/packet.c \
	networking/udhcp/signalpipe.c \
	networking/udhcp/socket.c \
	procps/free.c \
	procps/fuser.c \
	procps/iostat.c \
	procps/kill.c \
	procps/lsof.c \
	procps/mpstat.c \
	procps/nmeter.c \
	procps/pgrep.c \
	procps/pidof.c \
	procps/pmap.c \
	procps/powertop.c \
	procps/ps.c \
	procps/pstree.c \
	procps/pwdx.c \
	procps/renice.c \
	procps/smemcap.c \
	procps/sysctl.c \
	procps/top.c \
	procps/uptime.c \
	procps/watch.c \
	runit/chpst.c \
	shell/ash.c \
	shell/ash_ptr_hack.c \
	shell/cttyhack.c \
	shell/hush.c \
	shell/match.c \
	shell/math.c \
	shell/random.c \
	shell/shell_common.c \
	util-linux/blkid.c \
	util-linux/blockdev.c \
	util-linux/dmesg.c \
	util-linux/fatattr.c \
	util-linux/fbset.c \
	util-linux/fdisk.c \
	util-linux/findfs.c \
	util-linux/flock.c \
	util-linux/freeramdisk.c \
	util-linux/fstrim.c \
	util-linux/getopt.c \
	util-linux/hexdump.c \
	util-linux/hwclock.c \
	util-linux/ipcrm.c \
	util-linux/ipcs.c \
	util-linux/losetup.c \
	util-linux/lspci.c \
	util-linux/lsusb.c \
	util-linux/mdev.c \
	util-linux/mkfs_ext2.c \
	util-linux/mkfs_vfat.c \
	util-linux/mkswap.c \
	util-linux/more.c \
	util-linux/mount.c \
	util-linux/pivot_root.c \
	util-linux/rdate.c \
	util-linux/rdev.c \
	util-linux/readprofile.c \
	util-linux/rev.c \
	util-linux/rtcwake.c \
	util-linux/script.c \
	util-linux/scriptreplay.c \
	util-linux/setarch.c \
	util-linux/swaponoff.c \
	util-linux/switch_root.c \
	util-linux/umount.c \
	util-linux/volume_id/btrfs.c \
	util-linux/volume_id/cramfs.c \
	util-linux/volume_id/exfat.c \
	util-linux/volume_id/ext.c \
	util-linux/volume_id/f2fs.c \
	util-linux/volume_id/fat.c \
	util-linux/volume_id/get_devname.c \
	util-linux/volume_id/hfs.c \
	util-linux/volume_id/iso9660.c \
	util-linux/volume_id/jfs.c \
	util-linux/volume_id/linux_raid.c \
	util-linux/volume_id/linux_swap.c \
	util-linux/volume_id/luks.c \
	util-linux/volume_id/nilfs.c \
	util-linux/volume_id/ntfs.c \
	util-linux/volume_id/ocfs2.c \
	util-linux/volume_id/reiserfs.c \
	util-linux/volume_id/romfs.c \
	util-linux/volume_id/sysv.c \
	util-linux/volume_id/udf.c \
	util-linux/volume_id/util.c \
	util-linux/volume_id/volume_id.c \
	util-linux/volume_id/xfs.c

# DO NOT REMOVE next line, helper script use as automatic edit marker.
# END LOCAL_SRC_FILES

#LOCAL_CFLAGS += \
	-D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 \
	-Os \
	-Wno-char-subscripts \
	-Wno-sign-compare \
	-Wno-uninitialized \
	-Wno-unused-parameter \
	-funsigned-char \
	-ffunction-sections -fdata-sections \
	-fno-asynchronous-unwind-tables \
	-include $(LOCAL_PATH)/include/autoconf.h \
	-DANDROID \
	-D"KBUILD_STR(s)=\#s" \
	-D"BB_VER=KBUILD_STR($(BB_VER))" \
	-DBB_BT=AUTOCONF_TIMESTAMP

#LOCAL_LDFLAGS += \
	-lcrypt

#LOCAL_C_INCLUDES := \
	$(LOCAL_PATH)/include

LOCAL_MODULE := busybox
#LOCAL_MODULE_PATH := $(TARGET_OUT_OPTIONAL_EXECUTABLES)
#LOCAL_MODULE_TAGS := optional
#LOCAL_SHARED_LIBRARIES := libcutils

#include $(PREBUILT_STATIC_LIBRARY)
#include $(BUILD_EXECUTABLE)

# Make sybolic links to busybox.
# @note NOT ALL tools are included.

SYMLINK_TOOLS := \
	[ \
	[[ \
	test \
	awk \
	sed \
	seq \
	cut \
	dc \
	ed \
	expr \
	getopt \
	sort \
	printf \
	head \
	tail \
	rev \
	tr \
	xargs \
	wc \
	yes \
	uniq \
	usleep \

SYMLINK_TOOLS += \
	dirname \
	basename \
	find \
	readlink \
	realpath \

SYMLINK_TOOLS += \
	cp \
	zcat \
	ar \
	cpio \
	split \
	tac \

SYMLINK_TOOLS += \
	bzip2 \
	bunzip2 \
	gunzip \
	gzip \
	unzip \
	md5sum \
	tar \
	patch \

SYMLINK_TOOLS += \
	cmp \
	diff \
	od \
	hexdump \
	less \
	vi \
	expand \
	unexpand \

SYMLINK_TOOLS += \
	arp \
	arping \
	ipcalc \
	route \
	ipaddr \
	iplink \
        iptunnel \
	iproute \
	iprule \
	ifup \
	ifdown \
	nc \
	ping6 \
	rfkill \
	ether-wake \


SYMLINK_TOOLS += \
	iostat \
	rtcwake \
	losetup \
	lsof \
	pgrep \
	nohup \
	killall \
	killall5 \
	pkill \
	ipcrm \
	ipcs \

SYMLINK_TOOLS += \
	reset \
	setserial \
	stty \
	microcom \
	getty \
	login \
	passwd \

SYMLINK_TOOLS += \
	mkfifo \
	fdisk \
	findfs \
	mkfs.vfat \
	mkdosfs \
	fatattr \
	fstrim \
	blkid \

SYMLINKS := $(addprefix $(TARGET_OUT)/xbin/,$(SYMLINK_TOOLS))
$(SYMLINKS): BUSYBOX_BINARY := $(LOCAL_MODULE)
$(SYMLINKS): $(LOCAL_INSTALLED_MODULE) $(LOCAL_PATH)/Android.mk
	@echo "Symlink: $@ -> $(BUSYBOX_BINARY)"
	@mkdir -p $(dir $@)
	@rm -rf $@
	$(hide) ln -sf $(BUSYBOX_BINARY) $@

ALL_DEFAULT_INSTALLED_MODULES += $(SYMLINKS)

# We need this so that the installed files could be picked up based on the
# local module name
ALL_MODULES.$(LOCAL_MODULE).INSTALLED := \
    $(ALL_MODULES.$(LOCAL_MODULE).INSTALLED) $(SYMLINKS)

endif
